(function ($) {
    $(document).ready(function () {

        var count = $('.nikan_faqps .nikan_faqp_row').length;

        // Remove Row
        $(document).on('click','.nikan_faqp_remove_row',function (e) {
            if ($('.nikan_faqps .nikan_faqp_row').length !== 1) {
                $(this).parent().remove();
            }else {
                alert(nikan_faqp_object.remove_row_error);
            }
            e.preventDefault();
        });

        // Toggle row
        $(document).on('click','.nikan_faqp_open_row',function (e) {
            $(this).parent().toggleClass("active_faq_row");
            $(this).next().slideToggle(400);
            e.preventDefault();
        });

        // Keyup title
        $(document).on('keyup','.nikan_faqp_question_input > input',function () {
            if ($(this).val() !== '') {
                $(this).parent().parent().prev().prev().text($(this).val());
            }if ($(this).val() === '') {
                $(this).parent().parent().prev().prev().text(nikan_faqp_object.question_label);
            }
        });

        // Add new row
        $(document).on('click','.add-row',function (e) {
            count++;
            markup = "<div class='nikan_faqp_row'>" +
                        "<div class='nikan_faqp_remove_row'>" +
                            "<a href='#'>" +
                                "<i class='dashicons dashicons-dismiss'></i>" +
                            "</a>" +
                        "</div>"+
                         "<a class='nikan_faqp_accordion'>"+nikan_faqp_object.question_label+"</a>"+
                         "<button class='nikan_faqp_open_row'><i></i></button>"+
                         "<div class='nikan_faqp_form_row'> " +
                            "<div class='d-flex nikan_faqp_question_input'>" +
                                "<label for='nikan_faqp_question'>"+nikan_faqp_object.question_input +"</label>"+
                                "<input id='nikan_faqp_q_title' class='form-control' type='text' name='nikan_faqp_question[]' placeholder='"+nikan_faqp_object.question_input +"' required>" +
                            "</div>" +
                            "<div class='d-flex nikan_faqp_answer_input'>" +
                                "<label for='nikan_faqp_answer'>"+nikan_faqp_object.answer_input +"</label>"+
                                "<textarea id='nikan_faq_added_row"+count+"' class='form-control' type='text' name='nikan_faqp_answer[]' placeholder='"+nikan_faqp_object.answer_input +"' rows='4' cols='50'></textarea>" +
                            "</div>" +
                         "</div>" +
                     "</div>";

            let tableBody = $(".nikan_faqps");
            tableBody.append(markup);

            // Add Wordpress Editor
            if (nikan_faqp_object.textarea_type_wordpress === 'true'){
                wp.editor.initialize("nikan_faq_added_row"+count, {
                    tinymce: {
                        wpautop:true,
                        plugins : 'charmap colorpicker compat3x directionality fullscreen hr image lists  media paste tabfocus textcolor wordpress wpautoresize wpdialogs wpeditimage wpemoji wpgallery wplink wptextpattern wpview',
                        toolbar1: 'formatselect bold italic bullist numlist blockquote alignleft aligncenter alignright link unlink wp_more spellchecker'
                    },
                    quicktags: true,
                    mediaButtons: true,
                });
            }

            $('.nikan_faqp_dropme').dropme({replacerSize: true});

            e.preventDefault();
        });

        // Drag And Drop Feature
        var elmDrag, replacerSet = $();
        var eventStack = ['dragstart', 'dragend', 'selectstart', 'dragover', 'dragenter', 'drop'];

        $.fn.dropme = function(options) {

            var userOpt = options.toString();

            options = $.extend({
                linkTo: false
            }, options);

            if (options.contId) {
                //var elmes = '<ul class="sortable">';
                var elmes = '';
                var lnth = options.elem.length;
                var i;
                for (i = 0; i < lnth; i++) {
                    elmes += '<li id=' + options.elem[i].id + '>' + options.elem[i].title + '</li>';
                }
                // elmes += '</ul>';
                $('#' + options.contId + ' .dropme').html(elmes);
            }

            return this.each(function() {
                var regEx = new RegExp("/^enable|disable|destroy$/");
                if (userOpt.match(regEx)) {

                    var itemInOpt = $(this).data('items');

                    var items = $(this).children(itemInOpt);

                    if (userOpt == 'enable') {
                        items.attr('draggable', true);
                    } else {
                        items.attr('draggable', false);
                    }

                    if (userOpt == 'destroy') {
                        items.add(this).removeData('linkTo items').off(JSON.stringify(eventStack));
                    }
                    return;
                }
                var index, items = $(this).children(options.items);

                var replacer = $('<' + (this.tagName.match(/^ul|ol|div$/i) ? 'li' : 'div') + ' class="drop-replacer">');

                $(this).data('items', options.items);

                replacerSet = replacerSet.add(replacer);

                if (options.linkTo) {
                    $(options.linkTo).add(this).data('linkTo', options.linkTo);
                }

                items.attr('draggable', 'true').on(eventStack[0], function(e) {
                    var dataTrnsfr = e.originalEvent.dataTransfer;
                    dataTrnsfr.effectAllowed = 'move';
                    dataTrnsfr.setData('Text', 'dummy');
                    elmDrag = $(this);
                    index = (elmDrag).addClass('drop-elmDrag').index();
                }).on(eventStack[1], function() {
                    (elmDrag = $(this)).removeClass('drop-elmDrag').show();
                    replacerSet.detach();
                    if (index != elmDrag.index()) {
                        items.parent().trigger('sortupdate', {
                            item: elmDrag
                        });
                    }
                    elmDrag = null;
                }).not('a[href], img').on(eventStack[2], function() {
                    this.dragDrop && this.dragDrop();
                    return false;
                }).end().add([this, replacer]).on('dragover dragenter drop', function(event) {
                    if (!items.is(elmDrag) && options.linkTo !== $(elmDrag).parent().data('linkTo')) {
                        return true;
                    }
                    if (event.type == 'drop') {
                        event.stopPropagation();
                        replacerSet.filter(':visible').after(elmDrag);
                        return false;
                    }
                    event.preventDefault();
                    event.originalEvent.dataTransfer.dropEffect = 'move';
                    if (items.is(this)) {
                        if (options.replacerSize) {
                            replacer.height(elmDrag.outerHeight());
                        }
                        elmDrag.hide();
                        $(this)[replacer.index() < $(this).index() ? 'after' : 'before'](replacer);
                        replacerSet.not(replacer).detach();
                    } else if (!replacerSet.is(this) && !$(this).children(options.items).length) {
                        replacerSet.detach();
                        $(this).append(replacer);
                    }
                    return false;
                });
            });
        };

        $('.nikan_faqp_dropme').dropme({replacerSize: true});

    });

})(jQuery);
