<?php
/**
 * Register admin menu
 */
add_action('admin_menu','nikan_faqp_admin_menu');
function nikan_faqp_admin_menu(){
	add_submenu_page( 'edit.php?post_type=faqp', __( 'Setting', 'faq-plus' ), __( 'Setting', 'faq-plus' ), 'manage_options','faqp_setting', 'nikan_faqp_settings' );
}

/**
 * FAQ Settings
 */
function nikan_faqp_settings(){
    // Save Setting
    nikan_faqp_settings_saved();

    // Setting Template
    nikan_faqp_settings_html();
}

/**
 * Update Setting Options
 */
function nikan_faqp_settings_saved(){
    if (isset($_POST['nikan_faqp_save_settings'])){
        update_option('nikan_faqp_textarea_type',sanitize_text_field($_POST['textarea_type']));
        update_option('faqp_template_type',sanitize_text_field($_POST['faqp_template_type']));
    }
}

/**
 * Setting Html Template
 */
function nikan_faqp_settings_html(){
    $option = get_option('nikan_faqp_textarea_type');
    $template_type = get_option('faqp_template_type');
    ?>
    <form method="post">
        <p><?php esc_html_e('Your TextArea Type:', 'faq-plus'); ?></p>
        <input type="radio" id="wordpress" name="textarea_type" value="wordpress" <?php echo ($option and $option === 'wordpress') ? 'checked' : '' ?>>
        <label for="wordpress"><?php esc_html_e('Wordpress Text Editor', 'faq-plus'); ?></label><br><br>
        <input type="radio" id="simpleTextarea" name="textarea_type" value="simpleTextarea" <?php echo ($option and $option === 'simpleTextarea') ? 'checked' : '' ?>>
        <label for="simpleTextarea"><?php esc_html_e('Simple Textarea', 'faq-plus'); ?></label><br><br>

        <p><?php esc_html_e('Select FAQ Template', 'faq-plus'); ?></p>
        <div>
            <input type="radio" name="faqp_template_type" id="default" value="default" <?php if ($template_type === 'default' or !$template_type) echo 'checked'?>>
            <label for="default"><?php esc_html_e('Default', 'faq-plus'); ?></label><br><br>
            <input type="radio" name="faqp_template_type" id="bootstrap" value="bootstrap" <?php if ($template_type === 'bootstrap') echo 'checked'?>>
            <label for="bootstrap"><?php esc_html_e('Bootstrap', 'faq-plus'); ?></label><br><br>
        </div>

        <button class="button button-primary button-large" name="nikan_faqp_save_settings"><?php esc_html_e('Submit', 'faq-plus'); ?></button>
    </form>
    <?php
}


