<?php
/**
 * Register the post type
 */
add_action('init','nikan_faqp_post_type');
function nikan_faqp_post_type(){
	$labels = [
		'name'               => _x( 'FAQS', 'Post Type General Name', 'faq-plus' ),
		'singular_name'      => _x( 'FAQ', 'Post Type Singular Name', 'faq-plus' ),
		'menu_name'          => __( 'FAQ Plus', 'faq-plus' ),
		'parent_item_colon'  => __( 'Parent Faq', 'faq-plus' ),
		'all_items'          => __( 'All FAQ', 'faq-plus' ),
		'view_item'          => __( 'View FAQ', 'faq-plus' ),
		'add_new_item'       => __( 'Add FAQ', 'faq-plus' ),
		'add_new'            => __( 'Add New', 'faq-plus' ),
		'edit_item'          => __( 'Edit FAQ', 'faq-plus' ),
		'update_item'        => __( 'Update FAQ', 'faq-plus' ),
		'search_items'       => __( 'Search FAQ', 'faq-plus' ),
		'not_found'          => __( 'Not FAQ found', 'faq-plus' ),
		'not_found_in_trash' => __( 'Not FAQ in Trash', 'faq-plus' ),
	];
	$rewrite = [
		'slug'       => 'faq',
		'with_front' => true,
		'pages'      => true,
		'feeds'      => true,
	];
	$args = [
		'labels'              => $labels,
		'supports'            => [ 'title' ],
		'hierarchical'        => true,
		'public'              => true,
		'show_ui'             => true,
		'show_in_menu'        => true,
		'show_in_nav_menus'   => true,
		'show_in_admin_bar'   => true,
		'menu_position'       => 5,
		'menu_icon'           => 'dashicons-editor-help',
		'can_export'          => true,
		'has_archive'         => false,
		'exclude_from_search' => false,
		'publicly_queryable'  => true,
		'show_in_rest'        => true,
		'rewrite'             => $rewrite,
		'capability_type'     => 'post',
	];
	register_post_type( 'faqp', $args );
}

/**
 * Add Shortcode Columns
 */
add_action('manage_faqp_posts_columns', 'nikan_faqp_post_type_column');
function nikan_faqp_post_type_column($columns){
    $columns['nikan_faqp_shortcode'] = __('Shortcode', 'faq-plus');
    return $columns;
}

/**
 * Shortcode Columns Content
 */
add_action('manage_faqp_posts_custom_column', 'nikan_faqp_manage_post_type_column', 10, 2 );
function nikan_faqp_manage_post_type_column($column, $post_id){
    switch ($column) {
        case 'nikan_faqp_shortcode' :
            $questions =  get_post_meta( $post_id, 'nikan_faqp_question', true );
            $answers = get_post_meta( $post_id, 'nikan_faqp_answer', true );
            if (!empty($answers) and !empty($questions)) { ?>
                <div class="nikan_faqp_shortcode_box">
                    <code>
                        [faqp id=<?php echo $post_id?>]
                    </code>
                </div>
            <?php }
        break;
    }
}